import { Integration, Integrations } from '@agile-ts/core';
import Vue from 'vue';
import { bindAgileInstances } from './bindAgileInstances.js';

var __defProp = Object.defineProperty;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
const vueIntegration = new Integration({
  key: "vue",
  frameworkInstance: Vue,
  updateMethod: (componentInstance, updatedData) => {
    const componentData = componentInstance.$data;
    for (const key of Object.keys(updatedData)) {
      if (Object.prototype.hasOwnProperty.call(componentData, key)) {
        componentData.sharedState[key] = updatedData[key];
      } else {
        Vue.set(componentData.sharedState, key, updatedData[key]);
      }
    }
  },
  bind: (agile) => {
    Vue.use({
      install: (vue) => {
        vue.mixin({
          created: function() {
            this.$agile = agile;
          },
          methods: {
            bindAgileInstances: function(deps) {
              var _a;
              return {
                sharedState: __spreadValues(__spreadValues({}, ((_a = this == null ? void 0 : this.$data) == null ? void 0 : _a.sharedState) || {}), bindAgileInstances(deps, agile, this))
              };
            },
            bindAgileValues: function(deps) {
              var _a;
              return {
                sharedState: __spreadValues(__spreadValues({}, ((_a = this == null ? void 0 : this.$data) == null ? void 0 : _a.sharedState) || {}), bindAgileInstances(deps, agile, this, "value"))
              };
            },
            bindAgileOutputs: function(deps) {
              var _a;
              return {
                sharedState: __spreadValues(__spreadValues({}, ((_a = this == null ? void 0 : this.$data) == null ? void 0 : _a.sharedState) || {}), bindAgileInstances(deps, agile, this, "output"))
              };
            }
          }
        });
      }
    });
    return Promise.resolve(true);
  }
});
Integrations.addInitialIntegration(vueIntegration);
var vueIntegration$1 = vueIntegration;

export { vueIntegration$1 as default };
